$PBExportHeader$nvo_public_function.sru
forward
global type nvo_public_function from nonvisualobject
end type
end forward

type ust_ip_option_information from structure
	character		ttl
	character		tos
	character		flags
	character		optionssize
	long		optionsdata
end type

type ust_icmp_echo_reply from structure
	unsignedlong		address
	unsignedlong		status
	unsignedlong		roundtriphome
	unsignedinteger		datasize
	unsignedinteger		reserved
	unsignedlong		datapointer
	ust_ip_option_information		options
	character		data[250]
end type

global type nvo_public_function from nonvisualobject autoinstantiate
end type

type prototypes
Private:

Function ULong CreateMutexA(ULong lpsa, Boolean fInitialOwner, String lpszMutexName) Library 'kernel32.dll'
Function uint GetModuleFileNameA(ulong hModule,ref string lpFilename,ulong nSize) Library "kernel32.dll"
Function ulong GetCurrentDirectoryA(ulong nBufferLength,ref string lpBuffer) Library "kernel32.dll"
Function boolean CreateDirectoryA(string lpPathName,string lpSecurityAttributes) Library "kernel32.dll"
Function boolean RemoveDirectoryA(string lpPathName) Library "kernel32.dll"
Function ulong GetTempPathA(ulong nBufferLength,ref string lpBuffer) Library "kernel32.dll"
Function uint GetWindowsDirectoryA(ref string lpBuffer,uint uSize) Library "kernel32.dll"
Function uint GetSystemDirectoryA(ref string lpBuffer,uint uSize) Library "kernel32.dll"

Function boolean SetFileAttributesA(string lpFileName,ulong dwFileAttributes) LIBRARY "kernel32.dll"
Function ulong GetFileAttributesA(string lpFileName) LIBRARY "kernel32.dll"
Function boolean CopyFileA(ref string lpExistingFileName,ref string lpNewFileName,boolean bFailIfExists) LIBRARY "kernel32.dll"
Function boolean MoveFileA(ref string lpExistingFileName,ref string lpNewFileName) LIBRARY "kernel32.dll"
Function boolean GetDiskFreeSpaceA(string lpRootPathName,ref ulong lpSectorsPerCluster,ref ulong  lpBytesPerSector,ref ulong lpNumberOfFreeClusters,ref ulong lpTtoalNumberOfClusters) LIBRARY "kernel32.dll"
Function boolean GetVolumeInformationA(string lpRootPathName,ref string lpVolumeNameBuffer,ulong nVolumeNameSize,ref ulong lpVolumeSerialNumber,ref ulong lpMaximumComponentLength,ref ulong lpFileSystemFlags,ref string lpFileSystemNameBuffer,ulong nFileSystemNameSize) LIBRARY "kernel32.dll"
Function uint GetDriveTypeA(string lpRootPathName) LIBRARY "kernel32.dll"

Function int SetPaperSize(uint Width,uint Height,uint Orient) Library "mHand.dll"
Function boolean GetFileDateTime(string lpFileName,uint nMode,ref string lpDate,ref string lpTime) Library "mHand.dll"
Function boolean SetSystemDateTime(integer wYear,integer wMonth,integer wDay,integer wHour,integer wMinute,integer wSecond) Library "mHand.dll"

Function boolean GetUserNameA(ref string lpBuffer, ref ulong nSize) library "advapi32.dll"

Function Long GetLastError() Library 'kernel32.dll'

function long inet_addr(ref string addr) library "wsock32.dll"
function long IcmpCloseHandle(long IcmpHandle) library "icmp.dll"
function long IcmpSendEcho (long IcmpHandle,long DestinationAddress,string requestData,integer requestSize,long requestOption,ref ust_icmp_echo_reply replyBuffer,long replySize,long timeout ) library "icmp.dll"
function long IcmpCreateFile() library "icmp.dll"
end prototypes

forward prototypes
public function long uf_string_rightpos (string as_string1, string as_string2, long al_start, boolean ab_overendpos)
public function boolean uf_file_setattributes (string as_filename, string as_fileattributes)
public function string uf_file_getattributes (string as_filename)
public function boolean uf_directory_create (string as_pathname)
public function string uf_directory_getcurrent ()
public function boolean uf_file_isavailable (string as_filename)
public function boolean uf_file_move (string as_existingfilename, string as_newfilename, boolean ab_securitymode)
public function boolean uf_file_copy (string as_existingfilename, string as_newfilename, boolean ab_securitymode)
public function boolean uf_directory_remove (string as_pathname)
public function boolean uf_file_delete (string as_filename, boolean ab_securitymode)
public function boolean uf_file_rename (string as_oldfilename, string as_newfilename)
public function boolean uf_directory_isavailable (string as_pathname)
public function string uf_string_replaceall (string as_string1, string as_string2, string as_string3)
public function boolean uf_printer_setpapersize (unsignedinteger ai_width, unsignedinteger ai_height, unsignedinteger ai_orient)
public function datetime uf_file_getdatetime (string as_filename, unsignedinteger ai_mode)
public function string uf_directory_gettemp ()
public function string uf_directory_getwindows ()
public function string uf_directory_getsystem ()
public function string uf_disk_getvolumename (string as_rootpathname)
public function string uf_disk_getserialnumber (string as_rootpathname)
public function string uf_disk_gettype (string as_rootpathname)
public function string uf_disk_getcdrom ()
public function string uf_disk_getavailable ()
public function string uf_system_getlogonname ()
public subroutine uf_window_center (window aw_window)
public function string uf_application_getlocation ()
public function string uf_application_getfilename ()
public subroutine uf_about ()
public function boolean uf_application_isrunning ()
public function boolean uf_system_setdatetime (datetime adt_systemdatetime)
public function boolean uf_network_ping (string as_ipaddr)
public function boolean uf_file_copy (string as_existingfilename, string as_newfilename)
public function boolean uf_file_delete (string as_filename)
public function boolean uf_file_move (string as_existingfilename, string as_newfilename)
public function boolean uf_disk_isavailable (string as_rootpathname)
public function real uf_disk_getfreespace (string as_rootpathname)
end prototypes

public function long uf_string_rightpos (string as_string1, string as_string2, long al_start, boolean ab_overendpos);long ll_MaxPos=0,ll_NowPos

IF al_start<0 THEN RETURN 0

IF al_start=0 or al_start>Len(as_string1) THEN al_start=Len(as_string1)
IF ab_OverEndPos THEN
	as_string1=Left(as_string1,al_start+Len(as_string2)-1)
ELSE
	as_string1=Left(as_string1,al_start)
END IF

IF Len(as_string1)<Len(as_string2) THEN RETURN 0

ll_NowPos=Pos(as_string1,as_string2,1)
DO WHILE ll_NowPos<>0
	ll_MaxPos=ll_NowPos
	ll_NowPos=Pos(as_string1,as_string2,ll_NowPos+1)
LOOP

RETURN ll_MaxPos
end function

public function boolean uf_file_setattributes (string as_filename, string as_fileattributes);ulong ll_FileAttributes

ll_FileAttributes=GetFileAttributesA(as_FileName)

IF ll_FileAttributes=4294967295 THEN
	RETURN FALSE
END IF

as_FileAttributes=Upper(as_FileAttributes)

IF Pos(as_FileAttributes,"R+")>0 and Mod(ll_FileAttributes,2)  <  1 THEN ll_FileAttributes += 1
IF Pos(as_FileAttributes,"R-")>0 and Mod(ll_FileAttributes,2)  >  0 THEN ll_FileAttributes -= 1

IF Pos(as_FileAttributes,"H+")>0 and Mod(ll_FileAttributes,4)  <  2 THEN ll_FileAttributes += 2
IF Pos(as_FileAttributes,"H-")>0 and Mod(ll_FileAttributes,4)  >  1 THEN ll_FileAttributes -= 2

IF Pos(as_FileAttributes,"S+")>0 and Mod(ll_FileAttributes,8)  <  4 THEN ll_FileAttributes += 4
IF Pos(as_FileAttributes,"S-")>0 and Mod(ll_FileAttributes,8)  >  3 THEN ll_FileAttributes -= 4

IF Pos(as_FileAttributes,"A+")>0 and Mod(ll_FileAttributes,64) < 32 THEN ll_FileAttributes +=32
IF Pos(as_FileAttributes,"A-")>0 and Mod(ll_FileAttributes,64) > 31 THEN ll_FileAttributes -=32

RETURN SetFileAttributesA(as_FileName,ll_FileAttributes)
end function

public function string uf_file_getattributes (string as_filename);ulong ll_FileAttributes
string ls_FileAttributes=""

ll_FileAttributes=GetFileAttributesA(as_FileName)

IF ll_FileAttributes=4294967295 THEN
	SetNull(ls_FileAttributes)
ELSE
	IF Mod(ll_FileAttributes, 2) >  0 THEN ls_FileAttributes += "R"
	IF Mod(ll_FileAttributes, 4) >  1 THEN ls_FileAttributes += "H"
	IF Mod(ll_FileAttributes, 8) >  3 THEN ls_FileAttributes += "S"
	IF Mod(ll_FileAttributes,32) > 15 THEN ls_FileAttributes += "D"
	IF Mod(ll_FileAttributes,64) > 31 THEN ls_FileAttributes += "A"
END IF

RETURN ls_FileAttributes
end function

public function boolean uf_directory_create (string as_pathname);string ls_SecurityAttributes

SetNull(ls_SecurityAttributes)

RETURN CreateDirectoryA(as_PathName,ls_SecurityAttributes)
end function

public function string uf_directory_getcurrent ();string ls_Buffer

ls_Buffer=Space(255)

IF GetCurrentDirectoryA(255,ls_Buffer)=0 THEN SetNull(ls_Buffer)

RETURN ls_Buffer
end function

public function boolean uf_file_isavailable (string as_filename);Integer ls_FileHandle

//ļ·
IF Mid(as_FileName,2,2)<>":\" THEN RETURN FALSE

//ļԴ,ΪļЧ
ls_FileHandle=FileOpen(as_FileName)
IF ls_FileHandle=-1 THEN
	RETURN FALSE
ELSE
	FileClose(ls_FileHandle)
	RETURN TRUE
END IF
end function

public function boolean uf_file_move (string as_existingfilename, string as_newfilename, boolean ab_securitymode);string ls_NewFileAttributes

IF not uf_File_IsAvailable(as_ExistingFileName) THEN RETURN FALSE

//as_NewFileName·
IF Mid(as_NewFileName,2,2)<>":\" THEN
	//as_NewFileNameӸĿ¼ʼ·,Ϊas_ExistingFileName̷ͬ
	IF Left(as_NewFileName,1)="\" THEN
		as_NewFileName=Left(as_ExistingFileName,2)+as_NewFileName
	ELSE
		//as_NewFileName·Ϣ,
		//ȡas_ExistingFileNameľ·Ϣas_NewFileName֮ǰ
		as_NewFileName=Left(as_ExistingFileName,uf_String_RightPos(as_ExistingFileName,"\",0,FALSE))+as_NewFileName
	END IF
END IF

//as_NewFileNameһ·,as_ExistingFileNameļ
ls_NewFileAttributes=uf_File_GetAttributes(as_NewFileName)
IF not IsNull(ls_NewFileAttributes) THEN
	IF Pos(ls_NewFileAttributes,"D")>0 THEN
		IF Right(as_NewFileName,1)<>"\" THEN as_NewFileName+="\"
		as_NewFileName=as_NewFileName+Mid(as_ExistingFileName,uf_String_RightPos(as_ExistingFileName,"\",0,FALSE)+1)
	END IF
END IF

IF Upper(as_NewFileName)=Upper(as_ExistingFileName) THEN RETURN FALSE

IF ab_SecurityMode THEN
	IF FileExists(as_NewFileName) THEN RETURN FALSE
ELSE
	IF FileExists(as_NewFileName) THEN
		IF not uf_File_Delete(as_NewFileName,FALSE) THEN RETURN FALSE
	END IF
	uf_File_SetAttributes(as_ExistingFileName,"R-")
END IF

RETURN MoveFileA(as_ExistingFileName,as_NewFileName)
end function

public function boolean uf_file_copy (string as_existingfilename, string as_newfilename, boolean ab_securitymode);IF not uf_File_IsAvailable(as_ExistingFileName) THEN RETURN FALSE

IF ab_SecurityMode THEN
	RETURN CopyFileA(as_ExistingFileName,as_NewFileName,TRUE)
ELSE
	uf_File_SetAttributes(as_NewFileName,"R-")
	RETURN CopyFileA(as_ExistingFileName,as_NewFileName,FALSE)
END IF
end function

public function boolean uf_directory_remove (string as_pathname);RETURN RemoveDirectoryA(as_PathName)
end function

public function boolean uf_file_delete (string as_filename, boolean ab_securitymode);IF not ab_SecurityMode THEN uf_File_SetAttributes(as_FileName,"R-")

RETURN FileDelete(as_FileName)
end function

public function boolean uf_file_rename (string as_oldfilename, string as_newfilename);IF not uf_File_IsAvailable(as_OldFileName) THEN RETURN FALSE

//as_NewFileNameǷ·
IF Pos(as_NewFileName,"\")>0 THEN
	//:as_NewFileName·as_OldFileName·ͬ
	IF Upper(Left(as_OldFileName,uf_String_RightPos(as_OldFileName,"\",0,FALSE))) <> Upper(Left(as_NewFileName,uf_String_RightPos(as_NewFileName,"\",0,FALSE))) THEN RETURN FALSE
ELSE
	//:as_OldFileName·Ϊas_NewFileName·
	as_NewFileName=Left(as_OldFileName,uf_String_RightPos(as_OldFileName,"\",0,FALSE))+as_NewFileName
END IF

//as_NewFileNameȡ,˵as_NewFileNameѾڻһĿ¼
IF not IsNull(uf_File_GetAttributes(as_NewFileName)) THEN RETURN FALSE

RETURN MoveFileA(as_OldFileName,as_NewFileName)
end function

public function boolean uf_directory_isavailable (string as_pathname);String ls_Attributes

ls_Attributes=uf_File_GetAttributes(as_PathName)

IF IsNull(ls_Attributes) THEN RETURN FALSE

RETURN Pos(ls_Attributes,"D")>0
end function

public function string uf_string_replaceall (string as_string1, string as_string2, string as_string3);long ll_Pos,ll_F,ll_R

ll_F=Len(as_String2)
ll_R=Len(as_String3)

ll_Pos=Pos(as_String1,as_String2)
DO WHILE ll_Pos<>0
	as_String1=Replace(as_String1,ll_Pos,ll_F,as_String3)
	ll_Pos=Pos(as_String1,as_String2,ll_Pos+ll_R)
LOOP

RETURN as_String1
end function

public function boolean uf_printer_setpapersize (unsignedinteger ai_width, unsignedinteger ai_height, unsignedinteger ai_orient);RETURN (SetPaperSize(ai_Width,ai_Height,ai_Orient)=1)
end function

public function datetime uf_file_getdatetime (string as_filename, unsignedinteger ai_mode);string ls_Date,ls_Time
datetime ldt_ReturnValue

ls_Date=Space(10)
ls_Time=Space(8)

IF not GetFileDateTime(as_FileName,ai_Mode,ls_Date,ls_Time) THEN
	SetNull(ldt_ReturnValue)
	RETURN ldt_ReturnValue
END IF

ldt_ReturnValue=DateTime(Date(ls_Date),Time(ls_Time))

RETURN ldt_ReturnValue
end function

public function string uf_directory_gettemp ();string ls_Buffer
ulong ll_RequiredBufferSize

ls_Buffer=Space(255)
ll_RequiredBufferSize=GetTempPathA(255,ls_Buffer)

IF ll_RequiredBufferSize=0 or ll_RequiredBufferSize>255 THEN SetNull(ls_Buffer)

RETURN ls_Buffer
end function

public function string uf_directory_getwindows ();string ls_Buffer
ulong ll_RequiredBufferSize

ls_Buffer=Space(255)
ll_RequiredBufferSize=GetWindowsDirectoryA(ls_Buffer,255)

IF ll_RequiredBufferSize=0 or ll_RequiredBufferSize>255 THEN SetNull(ls_Buffer)

RETURN ls_Buffer
end function

public function string uf_directory_getsystem ();string ls_Buffer
ulong ll_RequiredBufferSize

ls_Buffer=Space(255)
ll_RequiredBufferSize=GetSystemDirectoryA(ls_Buffer,255)

IF ll_RequiredBufferSize=0 or ll_RequiredBufferSize>255 THEN SetNull(ls_Buffer)

RETURN ls_Buffer

end function

public function string uf_disk_getvolumename (string as_rootpathname);string ls_VolumeNameBuffer
ulong ll_VolumeSerialNumber
ulong ll_MaximumComponentLength
ulong ll_FileSystemFlags
string ls_FileSystemNameBuffer

as_RootPathName=Left(as_RootPathName,1)+":"
ls_VolumeNameBuffer=Space(20)
ls_FileSystemNameBuffer=Space(20)

IF not GetVolumeInformationA(as_RootPathName,ls_VolumeNameBuffer,20,ll_VolumeSerialNumber,ll_MaximumComponentLength,ll_FileSystemFlags,ls_FileSystemNameBuffer,20) THEN
	SetNull(ls_VolumeNameBuffer)
END IF

RETURN ls_VolumeNameBuffer
end function

public function string uf_disk_getserialnumber (string as_rootpathname);string ls_VolumeNameBuffer
ulong ll_VolumeSerialNumber
ulong ll_MaximumComponentLength
ulong ll_FileSystemFlags
string ls_FileSystemNameBuffer

as_RootPathName=Left(as_RootPathName,1)+":"
ls_VolumeNameBuffer=Space(20)
ls_FileSystemNameBuffer=Space(20)

IF not GetVolumeInformationA(as_RootPathName,ls_VolumeNameBuffer,20,ll_VolumeSerialNumber,ll_MaximumComponentLength,ll_FileSystemFlags,ls_FileSystemNameBuffer,20) THEN
	SetNull(ll_VolumeSerialNumber)
END IF

RETURN String(ll_VolumeSerialNumber)
end function

public function string uf_disk_gettype (string as_rootpathname);string ls_DriveType

as_RootPathName=Left(as_RootPathName,1)+":"

CHOOSE CASE GetDriveTypeA(as_RootPathName)
	CASE 2
		ls_DriveType="REMOVABLE"
	CASE 3
		ls_DriveType="FIXED"
	CASE 4
		ls_DriveType="REMOTE"
	CASE 5
		ls_DriveType="CDROM"
	CASE 6
		ls_DriveType="RAMDISK"
	CASE ELSE
		SetNull(ls_DriveType)
END CHOOSE

RETURN ls_DriveType
end function

public function string uf_disk_getcdrom ();integer li_i,li_start,li_end
string ls_CDRoms=""

li_start=Asc("A")
li_end=Asc("Z")

FOR li_i=li_start TO li_end
	IF uf_Disk_GetType(Char(li_i))="CDROM" THEN ls_CDRoms=ls_CDRoms+Char(li_i)
NEXT

RETURN ls_CDRoms
end function

public function string uf_disk_getavailable ();integer li_i,li_start,li_end
string ls_Avaiables=""

li_start=Asc("A")
li_end=Asc("Z")

FOR li_i=li_start TO li_end
	IF not IsNull(uf_Disk_GetType(Char(li_i))) THEN ls_Avaiables=ls_Avaiables+Char(li_i)
NEXT

RETURN ls_Avaiables
end function

public function string uf_system_getlogonname ();ulong ll_Size
string ls_Buffer

ll_Size=255
ls_Buffer=Space(255)

IF not GetUserNameA(ls_Buffer,ll_Size) THEN SetNull(ls_Buffer)

RETURN ls_Buffer
end function

public subroutine uf_window_center (window aw_window);long ll_ScreenH,ll_ScreenW
Environment	le_Env

GetEnvironment(le_Env)

ll_ScreenH = PixelsToUnits(le_Env.ScreenHeight, YPixelsToUnits!)
ll_ScreenW = PixelsToUnits(le_Env.ScreenWidth , XPixelsToUnits!)

aw_Window.Y = (ll_ScreenH - aw_Window.Height) / 2
aw_Window.X = (ll_ScreenW - aw_Window.Width ) / 2
end subroutine

public function string uf_application_getlocation ();string ls_Buffer=Space(255)

IF GetModuleFileNameA(Handle(GetApplication()),ls_Buffer,255)=0 THEN
	SetNull(ls_Buffer)
ELSE
	ls_Buffer=Left(ls_Buffer,uf_String_RightPos(ls_Buffer,"\",0,FALSE))
END IF

RETURN ls_Buffer
end function

public function string uf_application_getfilename ();string ls_Buffer=Space(255)

IF GetModuleFileNameA(Handle(GetApplication()),ls_Buffer,255)=0 THEN
	SetNull(ls_Buffer)
ELSE
	ls_Buffer=Mid(ls_Buffer,uf_String_RightPos(ls_Buffer,"\",0,FALSE)+1)
END IF

RETURN ls_Buffer
end function

public subroutine uf_about ();MessageBox("About","PowerBuilder    - PBEF v1.5~r~n~r~nhttp://blacktea.126.com~r~nhttp://blacktea.soim.net~r~ne-mail:blacktea@88998.com",Information!)
end subroutine

public function boolean uf_application_isrunning ();string ls_AppName

IF Handle(GetApplication())>0 THEN
	ls_AppName=GetApplication().AppName
	CreateMutexA(0,TRUE,ls_AppName)
	IF GetLastError()=183 THEN RETURN TRUE
END IF

RETURN FALSE
end function

public function boolean uf_system_setdatetime (datetime adt_systemdatetime);date ld_Date
time lt_Time
integer li_Year,li_Month,li_Day,li_Hour,li_Minute,li_Second

ld_Date = date(adt_SystemDateTime)
lt_Time = time(adt_SystemDateTime)

li_Year   = Year(ld_Date)
li_Month  = Month(ld_Date)
li_Day    = Day(ld_Date)
li_Hour   = Hour(lt_Time)
li_Minute = Minute(lt_Time)
li_Second = Second(lt_Time)

RETURN SetSystemDateTime(li_Year,li_Month,li_Day,li_Hour,li_Minute,li_Second)
end function

public function boolean uf_network_ping (string as_ipaddr);ulong lul_NetAddress
long ll_hFile,ll_ret
string ls_Message=Space(20)
ust_icmp_echo_reply preturn

lul_NetAddress=inet_addr(as_IPAddr)
IF lul_NetAddress=-1 THEN RETURN FALSE

ll_hFile=IcmpCreateFile()
IF ll_hFile = 0 THEN  RETURN FALSE
ll_ret=IcmpSendEcho(ll_hFile,lul_NetAddress,ls_Message,Len(ls_Message),0,preturn,282,200)
IcmpCloseHandle(ll_hfile)

RETURN ll_ret > 0
end function

public function boolean uf_file_copy (string as_existingfilename, string as_newfilename);RETURN uf_File_Copy(as_ExistingFileName,as_NewFileName,TRUE)
end function

public function boolean uf_file_delete (string as_filename);RETURN uf_File_Delete(as_FileName,TRUE)
end function

public function boolean uf_file_move (string as_existingfilename, string as_newfilename);RETURN uf_File_Move(as_ExistingFileName,as_NewFileName,TRUE)
end function

public function boolean uf_disk_isavailable (string as_rootpathname);RETURN not IsNull(uf_disk_GetType(as_RootPathName))
 
end function

public function real uf_disk_getfreespace (string as_rootpathname);ulong ll_SectorsPerCluster,ll_BytesPerSector,ll_NumberOfFreeClusters,ll_TtoalNumberOfClusters

IF not uf_Disk_IsAvailable(as_RootPathName) THEN RETURN -1

as_RootPathName=Left(as_RootPathName,1)+":"

IF not GetDiskFreeSpaceA(as_RootPathName,ll_SectorsPerCluster,ll_BytesPerSector,ll_NumberOfFreeClusters,ll_TtoalNumberOfClusters) THEN
	RETURN -1
ELSE
	RETURN Real(ll_SectorsPerCluster)*ll_BytesPerSector*ll_NumberOfFreeClusters
END IF
end function

on nvo_public_function.create
TriggerEvent( this, "constructor" )
end on

on nvo_public_function.destroy
TriggerEvent( this, "destructor" )
end on

event constructor;/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*                                                              |
|PowerBuilder 亯 1.5                           *
*                                                              |
|PowerBuilder 亯 ұдһС ṩ˶ʮ *
*PBûṩĺҪû (User Object) ʽװ |
|һЩAPICԿļⲿΪ PB 6.51  *
*VC 6.0                                                        |
|                                                              *
*PowerBuilder 亯 ȫѣûԴCԴ |
|룬ʹú޸ģԷվ                *
*                                                              |
|                                                              *
*㽫վϣϣͬʱϱվ  |
|                                                              *
*http://blacktea.126.com    http://blacktea.soim.net           |
|                                                              *
*e-mail:blacktea@88998.com                                     |
|                                                              *
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
end event

